<template>
  <div>
    <div
      class="text-subtitle1 tamano-letra-titulos-modulos letras-system margin-bottom-30px style-title-list-left"
    >
      Lista de Clientes
    </div>

    <div class="row">
      <div class="col">
        <q-table
          :filter="filter"
          :loading="datatableLoading"
          :data="datatable.items"
          :columns="datatable.headers"
          no-data-label="No existen registros para mostrar"
          no-results-label="No se encontró ningún resultado"
          loading-label="Cargando información"
          rows-per-page-label="Filas por página"
          :rows-per-page-options="[10, 20, 50, 100, 500]"
          :pagination-label="getPaginationLabel"
          :pagination.sync="pagination"
          @request="onRequest"
          row-key="_id"
          class="estilos-table"
          flat
        >
          <template v-slot:header="props">
            <q-tr :props="props">
              <q-th
                v-for="col in props.cols"
                :key="col.name"
                :props="props"
                class="cabecera-table"
              >
                {{ col.label }}
              </q-th>
            </q-tr>
          </template>
          <template v-slot:body-cell-index="props">
            <q-td> {{ props.rowIndex + 1 }} </q-td>
          </template>

          <template v-slot:body-cell-age="props">
            <q-td>
              <q-chip color="primary" text-color="white">
                {{ props.row.age }}
              </q-chip>
            </q-td>
          </template>

          <template v-slot:body-cell-file_image="props">
            <q-avatar>
              <template v-if="props.row.file_image">
                <img
                  :src="
                    urlStorage + '/images/customers/' + props.row.file_image
                  "
                />
              </template>
              <template v-else>
                <q-avatar color="primary" text-color="white">{{
                  props.row.avatar_initials
                }}</q-avatar>
              </template>
            </q-avatar>
          </template>

          <template v-slot:body-cell-acciones="props">
            <!--si se quiere editar una columna-->
            <!--{{props.row[props.col.name]}}-->
            <q-td align="center">
              <q-btn
                dense
                outline
                round
                color="blue"
                icon="edit"
                @click="editEl(props.row)"
                class="margin-button-action"
              ></q-btn>
              <q-btn
                dense
                outline
                round
                color="red"
                icon="delete"
                @click="deleteEl(props.row)"
              ></q-btn>
            </q-td>
          </template>
          <template v-slot:top>
            <q-input
              dense
              color="primary"
              debounce="500"
              placeholder="Buscar por Nombre, Apellidos, Correo, Fecha de Nacimiento"
              input-class="setWidthSearchTable"
              v-model="filter"
            >
              <!---->
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>
            <q-space />
            <q-btn
              unelevated
              class="my-button-style q-mt-md"
              color="primary"
              label="Nuevo"
              @click="newEl()"
            />
          </template>
          <template v-slot:no-data="{ icon, message, filter }">
            <div
              class="full-width row flex-center text-accent q-gutter-sm"
              style="font-size: 15px"
            >
              <q-icon size="2em" name="sentiment_dissatisfied" />
              <span>
                {{ message }}
              </span>
              <q-icon size="2em" :name="filter ? 'mdi-alert' : icon" />
            </div>
          </template>
          <template v-slot:pagination="scope">
            <div class="row justify-center">
              <q-pagination
                v-model="pagination.page"
                :max="pagesNumber"
                :max-pages="5"
                :direction-links="true"
                :boundary-links="true"
                :boundary-numbers="true"
                @input="fetchData()"
                icon-first="skip_previous"
                icon-last="skip_next"
                icon-prev="fast_rewind"
                icon-next="fast_forward"
              >
              </q-pagination>
            </div>
          </template>
        </q-table>
      </div>
    </div>

    <CreateCustomer
      :loading="loadingDataDrawer"
      :condition="condition"
      :openModal.sync="modalCreateOrUpdate"
      :openModalParent="modalCreateOrUpdate"
      :valueParent="el"
      @submitEdit="submitEdit"
      @submitCreate="submitCreate"
    />

    <ModalDeleteComponent
      label="el cliente"
      :openModal.sync="modalDelete"
      :openModalParent="modalDelete"
      :requestServer="requestServerDelete"
      @confirm="confirmDelete"
    />
  </div>
</template>

<script>
import CreateCustomer from "../../../components/drawer/CreateCustomer";
import ModalDeleteComponent from "../../../components/modals/Delete";

export default {
  components: {
    CreateCustomer,
    ModalDeleteComponent,
  },
  data() {
    return {
      urlStorage: process.env.URL_STORAGE,
      //drawer
      modalCreateOrUpdate: false,
      condition: "",
      loadingDataDrawer: false,
      //delete
      modalDelete: false,
      requestServerDelete: false,
      //table
      filter: "",
      datatable: {
        headers: [
          {
            label: "N°",
            sortable: true,
            align: "left",
            field: "index",
            name: "index",
          },
          {
            label: "Avatar",
            sortable: false,
            align: "left",
            field: "file_image",
            name: "file_image",
          },
          {
            label: "Nombres",
            sortable: true,
            align: "left",
            field: "name",
            name: "name",
          },
          {
            label: "Apellidos",
            sortable: true,
            align: "left",
            field: "last_name",
            name: "last_name",
          },
          {
            label: "Correo",
            sortable: true,
            align: "left",
            field: "email",
            name: "email",
          },
          {
            label: "Género",
            sortable: false,
            align: "left",
            field: "gender_format",
            name: "gender_format",
          },
          {
            label: "Edad",
            sortable: false,
            align: "left",
            field: "age",
            name: "age",
          },
          {
            label: "Fecha de Nacimiento",
            sortable: true,
            align: "left",
            field: "date_birthday",
            name: "date_birthday",
          },

          {
            label: "Fecha de Registro",
            sortable: false,
            align: "left",
            field: "created_at_format",
            name: "created_at_format",
          },
          {
            label: "Acciones",
            sortable: false,
            align: "center",
            name: "acciones",
          },
        ],
        items: [],
      },
      datatableLoading: true,
      //item selec
      el: {},
      //formato selec
      outlined: true,
      dense: true,

      //pagination
      pagination: {
        sortBy: "created_at",
        descending: true,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10,
      },
      pagesNumber: 0,

      //errors
      errors: {},
    };
  },
  methods: {
    fetchData(val) {
      this.getElements(
        this.pagination.page,
        this.pagination.rowsPerPage,
        this.filter
      );
    },
    getPaginationLabel(firstRowIndex, endRowIndex, totalRowsNumber) {
      return (
        firstRowIndex + "-" + endRowIndex + " de " + totalRowsNumber + " filas"
      );
    },
    onRequest(props) {
      const { page, rowsPerPage, sortBy, descending } = props.pagination;
      const filter = props.filter;
      this.pagination.page = page;
      this.pagination.rowsPerPage = rowsPerPage;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.getElements(page, rowsPerPage, filter);
    },
    deleteEl(row) {
      this.modalDelete = true;
      this.el = {
        id: row.id,
      };
    },
    confirmDelete() {
      this.requestServerDelete = true;
      this.$axios
        .delete("api/auth/v1/customer/" + this.el.id)
        .then((response) => {
          this.$q.notify({
            color: "positive",
            position: "bottom",
            message: response.data.data.message,
            icon: "check",
          });

          this.requestServerDelete = false;
          this.modalDelete = false;
          this.getElements(1, 10);
        })
        .catch((error) => {
          this.requestServerDelete = false;
          this.modalDelete = false;
        });
    },
    newEl() {
      this.el = {
        id: "",
        name: "",
        last_name: "",
        email: "",
        file_image: "",
        gender: 2,
        date_birthday: "01-01-1990",
      };
      this.modalCreateOrUpdate = true;
      this.loadingDataDrawer = false;
      this.condition = "Nuevo";
    },
    editEl(row) {
      this.modalCreateOrUpdate = true;
      this.loadingDataDrawer = false;
      this.condition = "Actualizar";
      this.el = {
        id: row.id,
        name: row.name,
        last_name: row.last_name,
        email: row.email,
        file_image: row.file_image,
        gender: row.gender,
        date_birthday: row.date_birthday,
      };
    },
    getElements(page, itemsPerPage, q = null) {
      let sortBy = this.pagination.sortBy
        ? this.pagination.sortBy
        : "created_at";
      let descending = this.pagination.descending ? "DESC" : "ASC";
      let endpoint = "api/auth/v1/customer";

      let url =
        endpoint +
        "?page=" +
        page +
        "&per_page=" +
        itemsPerPage +
        "&sort_by=" +
        sortBy +
        "&descending=" +
        descending;

      this.datatableLoading = true;
      if (q) {
        url = url + "&q=" + q;
      }

      //this.datatable.items = [];
      this.$axios.get(url).then((response) => {
        if (response.data.meta) {
          this.pagination.page = response.data.meta.pagination.current_page;
          this.pagination.rowsPerPage = response.data.meta.pagination.per_page;
          this.pagination.rowsNumber = response.data.meta.pagination.total;
          this.pagesNumber = response.data.meta.pagination.total_pages;
        }

        this.datatable.items = response.data.data;
        this.datatableLoading = false;
      });
    },
    submitEdit() {
      this.getElements(this.pagination.page, this.pagination.rowsPerPage);
    },
    submitCreate() {
      this.getElements(1, 10);
    },
  },
  created() {
    this.getElements(1, 10);
  },
};
</script>
